<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);die();
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['class_id']) or !checkIfIssetAndNotEmpty($postdata['class_id']) or
    !isset($postdata['section_id']) or !checkIfIssetAndNotEmpty($postdata['section_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning,$conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

$function_type = trim($postdata['function_type']);

$Faculty_Codes = $conn_rjllearning_specific->prepare("SELECT id FROM faculty_info WHERE userid = ? AND institution_id = ? AND branch_id = ?");
$Faculty_Codes->execute(array($userid, $institution_id, $branch_id));

// Fetch a single row instead of all
$result_faculty = $Faculty_Codes->fetch(PDO::FETCH_ASSOC);

// Check if the faculty exists
if ($result_faculty === false) {
    errorreturn("Faculty Not Found.");
}

// Retrieve the faculty_id from the result
$faculty_id = $result_faculty['id'];
function getSubjectwiseAttendance($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $subject_id, $username, $limit, $faculty_id, $function_type, $conn_rjllearning, $userid, $offset)
{

    $teacher_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);
    $class_section_subjects  = $teacher_data['class_section_subjects'];

    $class_incharge_roles = $teacher_data['class_incharge_roles'];
    $staff_access_modules = $teacher_data['staff_access_modules'];

    $check_faculty_status = checkFacultyModuleGranted($function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules, $class_id, $section_id, $subject_id, $conn_rjllearning);
    if ($check_faculty_status == false) {
        errorreturn("Access denied: You do not have the required permissions.");
    }

    $sql = "SELECT count(*) as total_rows FROM  student_attendance_subjectwise where institution_id =? and branch_id =?   and added_by = ?";
    $array_params = [$institution_id, $branch_id, $username];
    $sql_append_data = facultyFilterQueryAppend(
        $sql,
        $array_params,
        $function_type,
        $class_section_subjects,
        $class_incharge_roles,
        $staff_access_modules,
        $class_id,
        $section_id,
        $subject_id,
        $conn_rjllearning,
        1,
        1,
        1,
        1
    );

    $sql = $sql_append_data['sql'];           // Get the modified SQL
    $array_params = $sql_append_data['array_params']; // Updated parameters with filters
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {
        $sql_timetable = "SELECT * FROM student_attendance_subjectwise WHERE institution_id = ? AND branch_id = ? AND added_by = ?";
        $array_params = [$institution_id, $branch_id, $username];
    } else {
        $sql_timetable = "SELECT * FROM student_attendance_subjectwise WHERE institution_id = ? AND branch_id = ? AND added_by = ?";
        $array_params = [$institution_id, $branch_id, $username];
    }

    // Get the modified SQL and parameters with appended filters
    $sql_append_data = facultyFilterQueryAppend(
        $sql_timetable,
        $array_params,
        $function_type,
        $class_section_subjects,
        $class_incharge_roles,
        $staff_access_modules,
        $class_id,
        $section_id,
        $subject_id,
        $conn_rjllearning,
        1,
        1,
        1,
        1
    );

    $sql = $sql_append_data['sql'];           // Get the modified SQL
    $array_params = $sql_append_data['array_params']; // Updated parameters with filters

    // Prepare and execute the modified SQL query
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $rows = $stmt->fetchAll();


    $daywise_info = array();
    // end edited by hazari
    if (count($rows) >= 1) {

        // $sql = "SELECT id, name,admission_number 
        //         FROM students 
        //         WHERE s.institution_id = ? AND s.branch_id = ? AND s.class_id = ? AND s.section_id = ? and student_id";

        // // Prepare the statement
        // $stmt = $conn_rjllearning_specific->prepare($sql);

        // // Bind parameters and execute the query
        // $stmt->execute([$date, $subject_id, $institution_id, $branch_id, $class_id, $section_id,$rows['student_id']]);

        // // Fetch the results
        // $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

        foreach ($rows as $temp) {
            $daywise_info[]  = array('student_id' => $temp['student_id'], 'value' => $temp['value']);
        }
        $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows[0]['class_id']);
        $section = getSection($conn_rjllearning_specific, $institution_id, $rows[0]['section_id']);
        $branch_info =  getBranchInfo($conn_rjllearning_specific, $institution_id, $rows[0]['branch_id']);
        $subject_info = getSubject($conn_rjllearning_specific, $institution_id, $rows[0]['subject_id']);
        $array_return  = array(
            'institution_id' => $rows[0]['institution_id'],
            'branch_id' => $branch_info,
            'class_id' => $class_info,
            'section_id' => $section,
            'subject_id' => $subject_info,
            'date' => $rows[0]['date'],
            'students_info' => $daywise_info
        );
    } else {
        errorreturn("Student subjectwise attendance not found.");
    }
    if (count($rows) < 50) {

        return array('total_rows' => $totalrows, 'daywise_attendance_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'daywise_attendance_info' => $array_return, 'maxreach' => 0);
    }
}

if ($postdata['function_type']  == "fetch_subjectwise_attendance") {
    $class_id = trim($postdata['class_id']);
    $section_id = trim($postdata['section_id']);
    $subject_id = trim($postdata['subject_id']);
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }
    $limit = $postdata['limit'];
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    if ($limit !=  'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getSubjectwiseAttendance($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $subject_id, $username, $limit, $faculty_id, $function_type, $conn_rjllearning, $userid,  $offset);
        successreturn($success);
    } else {
        $success['data'] = getSubjectwiseAttendance($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $subject_id, $username, $limit, $faculty_id, $function_type, $conn_rjllearning, $userid,  null);
        successreturn($success);
    }
}
